--- Smac/main.c	2002-07-19 08:45:29.000000000 -0400
+++ Smac/main.c	2014-12-27 14:56:52.000000000 -0500
@@ -39,5 +39,4 @@
 
 
-
 #include <stdio.h>
 #include <stdlib.h>
@@ -51,34 +50,33 @@
 extern FILE * yyin;
 
-char *ExpandTildeName ( name )
-    char *name;
+const char *ExpandTildeName ( name )
+    const char *name;
 {
     struct passwd *pwd;
     char *home;
-    char *p = name + 1;
-    static char  buf [256];
+    static char  buf_dir_tmp [MAXPATHLEN];
     
-    if ( name [1] == '/' ) {        /* c'est moi */
-	if ( (home = (char *) getenv ( "HOME" )) == 0 )
+    if ( name [1] == '/' || name [1] == '\0') {   /* c'est moi */
+	if ((home = getenv ("HOME")) == NULL)
 	  return name;
-	(void) strcpy ( buf, home );
-	(void) strcat ( buf, name + 1 );
+	(void) strcpy ( buf_dir_tmp, home );
+	(void) strcat ( buf_dir_tmp, name + 1 );
     }
     else { /* c'est un autre */
-	int save;
+	const char *p;
+	char *pb;
 	
-	while ( *p && *p != '/' ) p++;
-	save = *p;
-	*p = 0;
-	pwd = getpwnam ( name + 1 );
-	*p = save;
+	for (p = name + 1, pb = buf_dir_tmp; *p && *p != '/'; p++)
+	  *pb++ = *p;
+	*pb = 0;
+	pwd = getpwnam (buf_dir_tmp);
 	if (  pwd ) {
-	    (void) strcpy ( buf, pwd ->  pw_dir);
-	    (void) strcat ( buf, p );
+	    (void) strcpy ( buf_dir_tmp, pwd ->  pw_dir);
+	    (void) strcat ( buf_dir_tmp, p );
 	}
 	else
 	  return name;
     }
-    return buf;
+    return buf_dir_tmp;
 }
 
@@ -86,5 +84,5 @@ int main()
 {
 #ifdef RUNTIMECHECK
-  char * m = init_smac(1024, 15);	/* taille pile = 1024,
+  const char * m = init_smac(1024, 15);	/* taille pile = 1024,
 					   tas = 2^15 octets */
   if (m) {
@@ -118,3 +116,3 @@ int main()
     Stack_Empty(Var_Stack);
   }
-}
+}
\ No newline at end of file
--- Smac/mem.c	2002-07-14 16:55:09.000000000 -0400
+++ Smac/mem.c	2014-12-27 22:39:17.000000000 -0500
@@ -385,5 +385,5 @@ void forbit_RTCfree(p)
 /* Initialisation des allocations, le tas fait 2^log2size */
 
-char * init_rtcmalloc(log2size)
+void * init_rtcmalloc(log2size)
      int log2size;
 {
--- Smac/mem.h	1995-02-22 08:05:55.000000000 -0500
+++ Smac/mem.h	2014-12-27 22:38:32.000000000 -0500
@@ -71,5 +71,5 @@ extern FCT ( void *, RTCCalloc,(int, int
 extern FCT ( void, forbit_RTCfree,(void *)	);
      
-extern FCT ( char *, init_rtcmalloc,(int)	);
+extern FCT ( void *, init_rtcmalloc,(int)	);
 
 /* strdup is not defined on all system (!!) */
--- Smac/memo.c	2006-10-16 16:33:16.000000000 -0400
+++ Smac/memo.c	2014-12-27 16:27:47.000000000 -0500
@@ -93,6 +93,4 @@ Instruction * just_a_mark(l, del)
 char * begin_block = (char *) "begin_block";
 
-FCT(    Instruction *, make_block,(List *, int));
-
 /* Un bloc non vide */
 
@@ -141,6 +139,6 @@ void memo_comma()
       /* ((c1, ..., cn), e2 = (sc1, ..,. scm)) -> (c1, ..., cn, sc1, ..,. scm)
 	 ou (c1, c2, e2 = (sc1, ..,. scm)) -> (c1, c2, cn, sc1, ..,. scm) */
-      int n1 = (int) *((char **) (e1->info));
-      int n2 = (int) *((char **) (e2->info));
+      intptr_t n1 = (intptr_t) *((char **) (e1->info));
+      intptr_t n2 = (intptr_t) *((char **) (e2->info));
 
       m = (char **) Malloc((n1 + n2 + 1) * sizeof(void *));
@@ -163,7 +161,7 @@ void memo_comma()
     if (e2->fct == make_comma) {
       /* (c1, e2 = (sc1, ..,. scn)) -> (c1, sc1, ..., scn) */
-      int n2 = (int) *((char **) (e2->info));
+      intptr_t n2 = (intptr_t) *((char **) (e2->info));
 
-      m = (char **) Malloc((n2 + 2) * sizeof(void *));
+      m = Malloc((n2 + 2) * sizeof(void *));
       m[0] = (char *) (n2 + 1);
       m[1] = (char *) e1;
@@ -232,5 +230,5 @@ void memo_funcall_nargs()
   if ((Memo->fct == just_a_mark) && 
       (Memo->info == some_args)) {
-    int narg = 1;
+    intptr_t narg = 1;
     List * l = Memo->previous;
     List ** p;
@@ -244,5 +242,5 @@ void memo_funcall_nargs()
     } while ((l->fct != just_a_mark) || (l->info != first_arg));
 
-    p = (m = (List **) Malloc((narg + 2) * sizeof(List *))) + narg + 1;
+    p = (m = Malloc((narg + 2) * sizeof(List *))) + narg + 1;
 
     do {
@@ -333,6 +331,6 @@ char * begin_of_list = (char *) "begin_o
 
 Instruction * preserve_list(ignore1, ignore2)
-    List * ignore1;
-    int ignore2;
+    List * ignore1 __attribute__((unused));
+    int ignore2 __attribute__((unused));
 { 
   /* sert juste de marque */
@@ -394,6 +392,6 @@ void end_of_list()
 
 Instruction * array_dims(ignore1, ignore2)
-    List * ignore1;
-    int ignore2;
+    List * ignore1 __attribute__((unused));
+    int ignore2 __attribute__((unused));
 {
   /* sert juste de marque */
--- Smac/memo.h	2002-07-14 06:21:46.000000000 -0400
+++ Smac/memo.h	2014-12-27 15:28:50.000000000 -0500
@@ -46,5 +46,5 @@
 #include "fctdecl.h"
 
-extern Type * the_abstract_type();
+extern Type * the_abstract_type(void);
 
 extern FCT(Type *, the_typed_var,(char ** var)	);
--- Smac/mylex.c	2002-07-19 08:51:38.000000000 -0400
+++ Smac/mylex.c	2014-12-27 22:36:00.000000000 -0500
@@ -44,7 +44,9 @@
 
 #include <stdio.h>
+#include <stdlib.h>
 #include "y.tab.h"
 #include "fctdecl.h"
 #include "smac.h"
+#include "mylex.h"
 
 char yytext[8196];
@@ -56,5 +58,5 @@ char previous_tchar[256];
 static int pt_file = 0;
 
-FCT(int, ie_getc,());
+FCT(static int, ie_getc, (void));
 
 void smac_read_new_file()
@@ -67,6 +69,10 @@ void smac_read_new_file()
 
 #ifdef XCORAL
+#include <X11/X.h>
+#include <X11/Xlib.h>
+#include "../main_text.h"
+#include "../ie_func.h"
 #include "smacXcoral.h"
-extern char err_msg[];
+extern const char err_msg[];
 
 int ie_getc()
@@ -82,6 +88,4 @@ int ie_getc()
   
   {
-    extern FCT(int, ie_the_char,(char *, int)	);
-    
     return (i_curseur == i_curseur_sup)
       ? 0
@@ -106,12 +110,10 @@ int ie_getc()
 #endif
 
-extern FCT(int, yyerror, (char *)	);
-
-int key_err(k)
-     char * k;
+static int key_err(k)
+     const char * k;
 {
   char msg[64];
   
-  sprintf(msg, "sorry %s refused", k);
+  snprintf(msg, sizeof msg, "sorry %s refused", k);
   yyerror(msg);
   
@@ -121,5 +123,5 @@ int key_err(k)
 #define error() previous_char = previous_tchar[--pt_file]
 
-int eof_error()
+static int eof_error()
 {
   error();
@@ -134,5 +136,5 @@ static int lex_error(c)
   
   msg[0] = c;
-  msg[1] = 0;
+  msg[1] = '\0';
   error();
   yyerror(msg);
--- Smac/mylex.h	1969-12-31 19:00:00.000000000 -0500
+++ Smac/mylex.h	2014-12-27 15:15:12.000000000 -0500
@@ -0,0 +1,7 @@
+#include <stdio.h>
+
+extern void yyerror(const char *msg);
+extern int yylex(void);
+extern void mylex_init(void);
+
+extern FILE *yyin;
\ No newline at end of file
--- Smac/operator.c	2006-10-16 16:31:08.000000000 -0400
+++ Smac/operator.c	2014-12-27 16:32:06.000000000 -0500
@@ -75,5 +75,5 @@
   *****************/
 
-Instruction * var_reference(mkident)
+static Instruction * var_reference(mkident)
      List * mkident;
 {
@@ -91,6 +91,4 @@ Instruction * var_reference(mkident)
 }
 
-FCT ( Instruction *, make_oper_asterisk,(List *, int)	);
-
 Instruction * make_oper_ampersand(l, del)
     List * l;
--- Smac/rename.h	2002-07-19 08:55:08.000000000 -0400
+++ Smac/rename.h	2014-12-27 14:32:29.000000000 -0500
@@ -78,5 +78,4 @@
 #define yyvs i_yyvs
 #define yyvsp i_yyvsp
-#define key_err i_key_err
 #define ncform_sccsid i_ncform_sccsid
 #define yyback i_yyback
--- Smac/smac.c	2006-10-16 16:37:56.000000000 -0400
+++ Smac/smac.c	2014-12-27 16:44:18.000000000 -0500
@@ -40,4 +40,7 @@
 
 #ifdef XCORAL
+#include <X11/X.h>
+#include <X11/Xlib.h>
+#include "../main_text.h"
 #include "smacXcoral.h"
 #else
@@ -70,4 +73,5 @@
 #include "Switch_.h"
 #include "smac.h"
+#include "mylex.h"
 
 extern int yyparse();
@@ -76,5 +80,4 @@ int yyinflag = 0;
 void load_file(int nl)
 {
-  extern void smac_read_new_file();
   int save_numlig = numlig;
 #ifndef mylex
@@ -216,6 +219,4 @@ char * init_smac(stacksize)
 #ifdef mylex
   {
-    extern void mylex_init();
-    
     mylex_init();
   }
@@ -262,4 +263,3 @@ char * init_smac(stacksize)
     return 0;
   }
-}
-
+}
\ No newline at end of file
--- Smac/smac.h	2002-07-19 08:48:23.000000000 -0400
+++ Smac/smac.h	2014-12-27 21:50:42.000000000 -0500
@@ -50,9 +50,11 @@ FCT(	char *, init_smac,(int, int)	); 
 #else
 FCT(	char *, init_smac,(int)		); 
-#endif     
+#endif
 
 extern int yyinflag;
-extern char * yyinfilename;
+extern const char * yyinfilename;
 extern int numlig;
+FCT(const char *, ExpandTildeName, (const char *)); 
+FCT(void, smac_read_new_file, (void)); 
 
-#endif
+#endif
\ No newline at end of file
